import * as i0 from '@angular/core';
import { Directive, Input, NgModule } from '@angular/core';
import * as _ from 'lodash';
import { FormGroup } from '@angular/forms';

class FormFormcontrolHighlightDirective {
    constructor(elementRef, renderer) {
        this.elementRef = elementRef;
        this.renderer = renderer;
        this.libFormFormcontrolHighlight = new FormGroup({});
        this.compareForm = new FormGroup({});
        this.controls = [];
        this.compareControls = [];
        this.isShowButton = false;
    }
    ngOnChanges(changes) {
        if (changes['appHighLightForm']?.firstChange) {
            this.compareForm = _.cloneDeep(this.libFormFormcontrolHighlight);
        }
        this.libFormFormcontrolHighlight.valueChanges
            .subscribe(form => {
            if (form) {
                this.isShowButton = !_.isEqual(this.libFormFormcontrolHighlight.value, this.compareForm.value);
                !!this.compareControls.length ? this.removeCompareArrayItem() : null;
                this.recursionElementCollection(this.elementRef.nativeElement.children, this.compareControls);
                const compare = this.getControlsChanged();
                this.clearStyles(compare);
                !!compare.length ? this.setStyle(compare) : this.removeStyle();
            }
        });
    }
    ngAfterViewInit() {
        this.recursionElementCollection(this.elementRef.nativeElement.children, this.controls);
    }
    recursionElementCollection(children, controls) {
        for (let i = 0; i < children.length; i++) {
            let el = children[i];
            !this.isIdElement(el) ? el.setAttribute('id', Math.random().toString()) : null;
            !!el.childNodes.length ? this.recursionElementCollection(el.children, controls) : this.setControlValue(el, controls);
        }
    }
    removeCompareArrayItem() {
        this.compareControls.splice(0, this.compareControls.length);
    }
    setStyle(compare) {
        compare.forEach(it => {
            let el = document.getElementById(it.id);
            this.isRadioType(it.type) ? this.setStyleRadio(it, el) : this.renderer.setStyle(el, 'border', '1px solid #61dafb');
        });
    }
    setStyleRadio(it, el) {
        // @ts-ignore
        let label = el.labels[0];
        if (it.isCheckedForRadioBtn) {
            this.renderer.setStyle(label, 'borderBottom', '1px solid #61dafb');
        }
    }
    setControlValue(element, controls) {
        let id = element.getAttribute('id');
        const type = element.getAttribute('type');
        const name = element.getAttribute('formcontrolname');
        // @ts-ignore
        const value = element?.value;
        if (this.isRadioType(type) && id) {
            // @ts-ignore
            const isCheckedForRadioBtn = document.getElementById(id).checked;
            controls.push({ id, name, value, type, isCheckedForRadioBtn });
        }
        else if (id) {
            controls.push({ id, name, value, type });
        }
    }
    isRadioType(type) {
        return type === 'radio';
    }
    isIdsCompare(id, anotherId) {
        return id === anotherId;
    }
    isIdElement(element) {
        return !!element.getAttribute('id');
    }
    clearStyles(compare) {
        this.controls.forEach(it => {
            compare.forEach(v => {
                if (!this.isIdsCompare(it.id, v.id)) {
                    this.isRadioType(it.type)
                        ?
                            this.removeStyleRadio(it)
                        :
                            this.renderer.removeStyle(document.getElementById(it.id), 'border');
                }
            });
        });
    }
    removeStyle() {
        this.controls.forEach(it => {
            this.isRadioType(it.type)
                ?
                    this.removeStyleRadio(it)
                :
                    this.renderer.removeStyle(document.getElementById(it.id), 'border');
        });
    }
    removeStyleRadio(control) {
        let el = document.getElementById(control.id);
        // @ts-ignore
        let label = el.labels[0];
        this.renderer.removeStyle(document.getElementById(label.id), 'borderBottom');
    }
    getControlsChanged() {
        return this.compareControls.filter(it => {
            return this.controls.find((val) => {
                return !this.isRadioType(it.type) ? this.getControlValue(it, val) : this.getControlValueRadio(it, val);
            });
        });
    }
    getControlValue(compareControlValue, controlValue) {
        if (this.isIdsCompare(compareControlValue.id, controlValue.id) && controlValue.value !== compareControlValue.value) {
            return { ...controlValue };
        }
    }
    getControlValueRadio(compareControlValue, controlValue) {
        if (this.isIdsCompare(compareControlValue.id, controlValue.id) && controlValue.isCheckedForRadioBtn !== compareControlValue.isCheckedForRadioBtn) {
            return { ...controlValue };
        }
    }
}
FormFormcontrolHighlightDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: FormFormcontrolHighlightDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive });
FormFormcontrolHighlightDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.0.2", type: FormFormcontrolHighlightDirective, selector: "[libFormFormcontrolHighlight]", inputs: { libFormFormcontrolHighlight: "libFormFormcontrolHighlight" }, usesOnChanges: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: FormFormcontrolHighlightDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[libFormFormcontrolHighlight]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { libFormFormcontrolHighlight: [{
                type: Input
            }] } });

class FormInputHighlightModule {
}
FormInputHighlightModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: FormInputHighlightModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
FormInputHighlightModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: FormInputHighlightModule, declarations: [FormFormcontrolHighlightDirective], exports: [FormFormcontrolHighlightDirective] });
FormInputHighlightModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: FormInputHighlightModule, imports: [[]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.0.2", ngImport: i0, type: FormInputHighlightModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        FormFormcontrolHighlightDirective
                    ],
                    imports: [],
                    exports: [
                        FormFormcontrolHighlightDirective
                    ]
                }]
        }] });

/*
 * Public API Surface of form-input-highlight
 */

/**
 * Generated bundle index. Do not edit.
 */

export { FormFormcontrolHighlightDirective, FormInputHighlightModule };
//# sourceMappingURL=form-input-highlight-two.mjs.map
